#cs ----------------------------------------------------------------------------

 Moses Clicker Version 0.4
 Author:         Samuel Price   Copyright, 2008

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

AutoIt Version: 3.1.1.0
#ce ----------------------------------------------------------------------------

#include <GUIConstants.au3>
#include <Misc.au3>
$dll=DllOpen("user32.dll")

Global $click = False
Global $optopen = True
Global $holdkey = "10"
Global $usekey = True
Global $repeat = True

$winWid = 210
$winHig = 210

; ------ polling interval dropdown --------
$pollctrl=40  		;  - set polling interval to be 1/25th second.

Opt("GUIOnEventMode", 1)
;---------create gui------------------------------
$mainwindow = GUICreate("Moses Clicker v0.4",$winWid,$winHig,-1,-1,BitOR($WS_SYSMENU, $WS_VISIBLE, $WS_MINIMIZEBOX),$WS_EX_TOPMOST)
GUISetIcon(@SystemDir&"\shell32.dll",159)  ; 268
TraySetIcon(@SystemDir&"\shell32.dll",159)
GUISetOnEvent($GUI_EVENT_CLOSE, "close")

$conmenu = GuiCtrlCreateContextMenu ()
$aboutitem = GuiCtrlCreateMenuitem ("About",$conmenu)
GUICtrlSetOnEvent(-1,"aboutfunc")
	
$startbutton = GUICtrlCreateButton("&Start",0,0)
GUICtrlSetOnEvent($startbutton,"startclick")
$optbutton = GUICtrlCreateButton("Hide &Opts",145,0,59)
GUICtrlSetOnEvent($optbutton,"chgopts")

$checkbox = GUICtrlCreateCheckbox("active",42,0)
$chkbox2 = GUICtrlCreateCheckbox("down",97,0)
GUICtrlSetState($checkbox,$GUI_DISABLE+$GUI_UNCHECKED)
GUICtrlSetState($chkbox2,$GUI_DISABLE+$GUI_UNCHECKED)

;----------------------------------------------------------------
GUICtrlCreateGroup("",0,23,204,55)
GUICtrlSetResizing(-1,$GUI_DOCKALL)   
GUICtrlSetTip(-1,"Using a mouse button is not recommended" & @CR & "See the help file","Note:")

$label1=GUICtrlCreateLabel("Only click when this key is pushed:",10,33,-1,15)  ;0,28,210,45
GUICtrlSetTip(-1,"Using a mouse button is not recommended" & @CR & "See the help file","Note:")
$holdkeyComb=GUICtrlCreateCombo("",30,50,130,21)
GUICtrlSetTip(-1,"Using a mouse button is not recommended" & @CR & "See the help file","Note:")

Opt("GUIDataSeparatorChar",'~')
$longlist="Left Mouse Button~Right Mouse Button~Middle Mouse Button~Mouse 4~Mouse 5~Shift~CTRL~ALT"
$longlist=$longlist&"~CAPS~SPACE"
GUICtrlSetData($holdkeyComb,$longlist,"Shift")
GUICtrlSetOnEvent($holdkeyComb,"ChangeKey")

$PushMod=GUICtrlCreateCheckbox("",10,52)
GUICtrlSetOnEvent($PushMod,"enabkey")
GUICtrlSetState($PushMod,$GUI_CHECKED)


;---------------------------------------------------------------
GUICtrlCreateGroup("",0,74,204,55)
GUICtrlSetResizing(-1,$GUI_DOCKALL)  
$msbtnlable=GUICtrlCreateLabel("Which button to click?",45,85,-1,12)
$msbtnradleft=GUICtrlCreateRadio("Left",45,100,50)
$msbtnradright=GUICtrlCreateRadio("Right",105,100,50)
GUICtrlSetState($msbtnradright,$GUI_CHECKED)


;  ----- delay between clicks dropdown -------
GUICtrlCreateGroup("",0,125,204,60)
GUICtrlSetResizing(-1,$GUI_DOCKALL)  
$delayctrl=GUICtrlCreateinput("500",110,137,70,20) ;default time of 500ms
$updown=GUICtrlCreateUpdown($delayctrl)
GUICtrlSetLimit($updown,1000000,100)
$label2=GUICtrlCreateLabel("Repeat delay (ms)",15,140)
;$lable3=GUICtrlCreateLabel("Only click once (no repeat)",40,162)
$norepchk = GUICtrlCreateCheckbox("Only click once (no repeat)",25,158)
GUICtrlSetTip(-1,"Use this option to replace mouse clicks with key pushes","Note:")
GUICtrlSetOnEvent($norepchk,"norepkey")


;--------- make all option controlls stay put
GUICtrlSetResizing($holdkeyComb,$GUI_DOCKALL)
GUICtrlSetResizing($label1,$GUI_DOCKALL)
GUICtrlSetResizing($PushMod,$GUI_DOCKALL)
GUICtrlSetResizing($delayctrl,$GUI_DOCKALL)
GUICtrlSetResizing($label2,$GUI_DOCKALL)
GUICtrlSetResizing($msbtnlable,$GUI_DOCKALL)  
GUICtrlSetResizing($msbtnradleft,$GUI_DOCKALL)         
GUICtrlSetResizing($msbtnradright,$GUI_DOCKALL) 
GUICtrlSetResizing($norepchk,$GUI_DOCKALL)   

WinMove($mainwindow,"",Default,Default,$winWid,$winHig)  ; resize window

;aboutfunc()

;EXIT

;---------main code-------------------------

while 1
	GUICtrlSetState($chkbox2,$GUI_UNCHECKED)
	

if $click and WinActive($mainwindow)=0 Then					; if the clicker is active
	; - First check which mouse button needs clicking.---
	if BitAND(GUICtrlRead($msbtnradleft),$GUI_CHECKED)=$GUI_CHECKED Then
		$msbtn2clk="left" 
	Else
		$msbtn2clk="right"
	EndIf
	
	if $usekey Then				; if "only click when this key is pushed" is ticked
		if _IsPressed($holdkey,$dll) Then  ; if button is pushed.
			MouseClick($msbtn2clk)  	;do mouse click
			GUICtrlSetState($chkbox2,$GUI_CHECKED) ; set the "down" checkbox.
			if not $repeat Then
				while $click and _IsPressed($holdkey,$dll)
					msleep($pollctrl)
				WEnd
			Else
				msleep(GUICtrlRead($delayctrl)-$pollctrl)
			EndIf
		endif
	Else					; just click away if the "only click" box is unchecked.
		MouseClick($msbtn2clk)
		msleep(GUICtrlRead($delayctrl)-$pollctrl)		;sleep for delay - polling interval
		GUICtrlSetState($chkbox2,$GUI_CHECKED) ; set the "down" checkbox.
	EndIf
EndIf


	sleep($pollctrl)  				
WEnd

Func enabkey()
	if BitAND(GUICtrlRead($PushMod),$GUI_UNCHECKED) Then
		GUICtrlSetState($holdkeyComb,$GUI_DISABLE)
		GUICtrlSetState($chkbox2,$GUI_UNCHECKED)
		$usekey=False
		GUICtrlSetState($norepchk,$GUI_DISABLE)
		GUICtrlSetState($norepchk,$GUI_UNCHECKED)
		norepkey()
	Else
		GUICtrlSetState($holdkeycomb,$GUI_ENABLE)
		$usekey=True
		GUICtrlSetState($norepchk,$GUI_ENABLE)
		norepkey()
	EndIf
EndFunc

Func norepkey()
	if BitAND(guictrlread($norepchk),$GUI_UNCHECKED) Then
		guictrlsetstate($delayctrl,$GUI_ENABLE)
		$repeat = True
	Else
		GUICtrlSetState($delayctrl,$GUI_DISABLE)
		$repeat = False
	EndIf
EndFunc

Func chgopts()
	if $optopen Then
		WinMove($mainwindow,"",Default,Default,$winWid,50)
		GUICtrlSetData($optbutton,"Show &Opts")
		$optopen = False
	Else
		WinMove($mainwindow,"",Default,Default,$winWid,$winHig)
		GUICtrlSetData($optbutton,"Hide &Opts")
		$optopen = True
	EndIf
EndFunc


Func startclick()
	if $click Then
		$click = False
		GUICtrlSetState($checkbox,$GUI_UNCHECKED)
		ControlSetText ($mainwindow,default,$startbutton,"&Start")
	Else
		$click = True
		GUICtrlSetState($checkbox,$GUI_CHECKED)
		ControlSetText ($mainwindow,default,$startbutton,"S&top")
	EndIf
EndFunc


Func close()
	$click = False
	Exit
EndFunc

Func ChangeKey()
	$HKR=GUICtrlRead($holdkeyComb)
		Select
		Case $HKR="Left Mouse Button"
			$holdkey="01"
		Case $HKR="Right Mouse Button"
			$holdkey="02"
		Case $HKR="Middle Mouse Button"
			$holdkey="04"
		Case $HKR="Mouse 4"
			$holdkey="05"
		Case $HKR="Mouse 5"
			$holdkey="06"
		Case $HKR="Shift"
			$holdkey="10"
		Case $HKR="CTRL"
			$holdkey="11"
		Case $HKR="ALT"
			$holdkey="12"
		Case $HKR="CAPS"
			$holdkey="14"
		Case $HKR="SPACE"
			$holdkey="20"
		case Else
			MsgBox(-1,"Error","your program sucks")
		EndSelect
		
EndFunc

; my sleep. sleeps for pollctrl periods repeatedly until sleep period completed.
; implemented to improve response when using large delay periods.
Func mSleep($mDelay) 
    while $click and $mdelay > $pollctrl
        sleep($pollctrl)
        $mdelay = $mdelay - $pollctrl
    WEnd
    sleep($mdelay)
EndFunc


func aboutfunc()
	GUISetState(@SW_DISABLE,$mainwindow)
	Opt("GUIOnEventMode", 0)
	opt("RunErrorsFatal",0)  ;prevents script crashing if no default browser set up or wierd windows error when trying to open browser.
	$aboutwin = GUICreate("About",456,241,-1,-1,$WS_POPUPWINDOW,$WS_EX_TOPMOST,$mainwindow)
	GUISetState(@SW_SHOW)

	guictrlcreatepic(@WindowsDir & "\Santa Fe Stucco.bmp",0,0,456,15,-1,$GUI_WS_EX_PARENTDRAG)
	GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
;~ 	guictrlcreatepic(@WindowsDir & "\greenstone.bmp",0,15,456,226)
;~ GuiCtrlSetState(-1,$GUI_DISABLE)
;~ 	GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
	
;~ 	GuiCtrlSetState(-1,$GUI_DISABLE)
	$abtlab1=GUICtrlCreateLabel("Moses Clicker v0.4",170,15,150)
	GUICtrlSetFont(-1, 10, 800, 0, "Arial")
	$abtlab2=GUICtrlCreateLabel("Copyright 2008 Samuel Price",155,33,200)
	GUICtrlSetFont(-1, 8, 400, 0, "Arial")
        $abtlab3=GUICtrlCreateLabel("For help on using this product please see the readme.txt file included or visit:",15,60,420)
	GUICtrlSetFont(-1, 9, 400, 0, "Arial")
        
        $helplab=GUICtrlCreateLabel("www.mosesclicker.com/usage.htm",136,76)
	GUICtrlSetCursor ( -1, 0 )
	GUICtrlSetFont(-1, 8, 400, 4, "MS Sans Serif")
	GUICtrlSetColor(-1, 0x0000FF)

	$abtlab4=GUICtrlCreateLabel("If you liked this program, spotted any bugs or have any suggestions for",25,98,404)
	GUICtrlSetFont(-1, 9, 400, 0, "Arial")
	$abtlab5=GUICtrlCreateLabel("new features please contact me at:",136,112,195)
	GUICtrlSetFont(-1, 9, 400, 0, "Arial")
	$emaillab=GUICtrlCreateedit("samueldprice@yahoo.co.uk",152,129,145,25,bitor($ES_READONLY,$WS_DLGFRAME))

	$abtlab6=GUICtrlCreateLabel("This program is distributed under the terms of the GNU General Public License.",16,160,450)
	GUICtrlSetFont(-1, 9, 400, 0, "Arial")
	$abtlab7=GUICtrlCreateLabel("For details please see the file entitled 'Licence.txt', or visit:",75,173,450)
	GUICtrlSetFont(-1, 9, 400, 0, "Arial")

	$liclab=GUICtrlCreateLabel("www.mosesclicker.com/licence.htm",134,190)
	GUICtrlSetCursor ( -1, 0 )
	GUICtrlSetFont(-1, 8, 400, 4, "MS Sans Serif")
	GUICtrlSetColor(-1, 0x0000FF)

	$okbtn=GUICtrlCreateButton("OK",190,210,70)
	
	While 1
    $nMsg = GUIGetMsg()
    Switch $nMsg
        Case $okbtn
            ExitLoop
        Case $liclab
		$URL = "http://www.mosesclicker.com/licence.htm"
		Run(@ComSpec & " /c  rundll32 url.dll,FileProtocolHandler " & $URL, "", @SW_HIDE)
        Case $helplab
		$URL = "http://www.mosesclicker.com/usage.htm"
		Run(@ComSpec & " /c  rundll32 url.dll,FileProtocolHandler " & $URL, "", @SW_HIDE)
    EndSwitch
	WEnd
	GUIDelete($aboutwin)
	Opt("GUIOnEventMode", 1)
	GUISetState(@SW_ENABLE,$mainwindow)
EndFunc
